MrPaul_TUser's blog

By MrPaul_TUser, history, 2 years ago, In English

1593A - Elections

Idea: MikeMirzayanov

Tutorial
Solution

1593B - Make it Divisible by 25

Idea: MikeMirzayanov

Tutorial
Solution

1593C - Save More Mice

Idea: ITMO student team

Tutorial
Solution

1593D1 - All are Same

Idea: MikeMirzayanov

Tutorial
Solution

1593D2 - Half of Same

Idea: MikeMirzayanov

Tutorial
Solution

1593E - Gardener and Tree

Idea: MikeMirzayanov

Tutorial
Solution

1593F - Red-Black Number

Idea: MikeMirzayanov

Tutorial
Solution

1593G - Changing Brackets

Idea: nastya_ka

Tutorial
Solution
  • Vote: I like it
  • +54
  • Vote: I do not like it

| Write comment?
»
2 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone explain the solution to F pls

  • »
    »
    2 years ago, # ^ |
    Rev. 4   Vote: I like it +3 Vote: I do not like it

    F is a dynamic programming problem. You can use

    • taken amount

    • red digits count

    • the rem of red number mod a

    • the rem of black numer mod b

    to describe a state.The taken amount is phase of the dp. If you use enumeration method to find all states, the amount of states is $$$2^{40}$$$. But if you use dp to descibe all states, the amount of states is only $$$40^4$$$.

    Here is my code, written in Python3, but it get TLE. https://codeforces.com/contest/1593/submission/132439261

    Here is the same code rewritten by C++, it get AC. https://codeforces.com/contest/1593/submission/132442220

    I think the python code is more clearly than C++ code.

»
2 years ago, # |
  Vote: I like it +5 Vote: I do not like it

d2 is really intresting.

»
2 years ago, # |
  Vote: I like it +3 Vote: I do not like it

It seems that in the tutorial for A, the answer should be max(0, max(b,c) + 1 — a) (as in the solution code), instead of min(0, max(b,c) + 1 — a).

»
2 years ago, # |
  Vote: I like it +16 Vote: I do not like it

We don't need that extra array to recover answer string. We can store masks in DP and recover the answer from that. Submission with comments : 131983798

»
2 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Your dp is so messy.(F) -__-
Good problemset btw.

»
2 years ago, # |
  Vote: I like it 0 Vote: I do not like it
  • »
    »
    2 years ago, # ^ |
      Vote: I like it +3 Vote: I do not like it

    Thank you very much, I was having a bug for a long time and I had no idea what it could be (눈‸눈)

    • »
      »
      »
      2 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Feeling nice to hear that it helped.

»
2 years ago, # |
Rev. 3   Vote: I like it 0 Vote: I do not like it

For the E problem, will the standard graph bfs not work? I pushed all the leaves ( adjacency list size == 1 ) to a queue and assigned them a distance of 1 ( distance = number of times the operation has to be performed to cut off that node ). Then I performed a bfs assigning increasing distance. Answer is simply all the nodes whose distance is greater than k. This is failing though. Please if somebody could help me out. Thanks in advance

https://codeforces.com/contest/1593/submission/132264294

UPD : I changed the visited logic to an in-degree logic while preserving the bfs (AC : 132341078). Hope somebody finds this helpful. Thank you dedsec_29

  • »
    »
    2 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Once you mark a node visited, your code will never update its distance. But this is incorrect. You have to mark a node visited only when it becomes a leaf. If you mark it before it becomes a leaf, d[i] will no longer denote iterations after which the node is no longer part of tree

    • »
      »
      »
      2 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      "If you mark it before it becomes a leaf, d[i] will no longer denote iterations after which the node is no longer part of tree."

      Can you justify this with a counter-example please? I tried a lot of manual cases (Sample cases passed too), every time the node gets marked as visited, it is correctly assigned the distance from the closest leaf. Say the distance of the node is 3 from the closest leaf and k=3, so that node will be cut off at the end of all k operations, right? Or am I missing something? Thanks again.

      • »
        »
        »
        »
        2 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        Take this test case for example:

        1
        8 2
        1 2
        2 3
        3 4
        4 5
        5 6
        6 7
        8 3

        Your output: 2
        Correct output: 3
        Your code deletes node 3 as you mark the distance 2 for it, but it will be deleted in the 3rd iteration, so d[3] should be 3, not 2

  • »
    »
    2 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Thanks man

»
2 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it
  • Can Someone help with the time complexity of this code: https://codeforces.com/contest/1593/submission/132395142 for problem D2.
  • I have used dp table for calculating the maximum gcd possible when I consider exactly n/2 numbers( because I have to make atleast half elements equal)
  • dp[i][cnt][last] stores set of GCDs that are possible after considering cnt number of elements upto ith position in the array with index of previous selected element as last.
  • It got submitted with 15ms runtime. According to me, the time complexity of this code is O(n^5 * (log(max(Ai)) + log(n))). I want to know whether I am wrong with the time complexity or test cases are not strong enough !
Reason behind asking this question
»
2 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Did anyone solve F using meet in the middle idea ?

  • »
    »
    2 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I'm trying to do it here but I need a way to combine the answer faster, I'm doing it in O(2^(n/2)*a*b) but it didn't pass.

»
2 years ago, # |
  Vote: I like it 0 Vote: I do not like it

My idea for E was to look at one diameter of the tree and take a middle point in that diameter. After that i root the tree in this middle point and after that it's easy but unfortunately i got memory limit exceeded. Is this idea works?

  • »
    »
    2 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    yes this idea works, be careful on how you are finding middle point(s) when diameter is even or odd. code

»
2 years ago, # |
  Vote: I like it 0 Vote: I do not like it

CAN F QUESTION DE DONE USING MEET INT THE MIDDLE?

  • »
    »
    2 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Yes, but you need to write it with very low constant factor. You can check my submission here

»
2 years ago, # |
Rev. 3   Vote: I like it 0 Vote: I do not like it

deleted

  • »
    »
    2 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Because maximum difference is 1e6 — (-1e6) = 2 * 1e6; not 1e12

»
7 months ago, # |
  Vote: I like it 0 Vote: I do not like it

I found it in the code written in D1, and when I copied the code and confirmed it, it gave me: WA on test 1 After two years I discovered the error In the coming days, we must test the code before publishing it :)

  • »
    »
    7 months ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    When removing a "break", the code became valid, and the reason for this is that the written code must come in a smaller number, and this is a simpler code number.

    #include <bits/stdc++.h>
    
    using namespace std;
    
    int main()
    {
    	
    	int t=0; cin>>t; 
    	while(t--){
    	    bool s=1;
    	    int n,mn=1e9; cin>>n;
    	    int x[n];
    	    for(int i=0;i<n;i++){cin>>x[i]; if(i>0&&x[i]!=x[i-1])s=0;mn=min(mn,x[i]);}
    	    if(s)cout<<-1<<endl;
    	    else{int ans=0;
    	    for(int i=0;i<n;i++){
    	        ans=__gcd(ans,x[i]-mn);
    	    }
    	    cout<<ans<<endl;
    	    }
    	}
    
    	return 0;
    }
    
»
5 months ago, # |
  Vote: I like it 0 Vote: I do not like it

Can anycody give a counter case in which this approach fails for the problem E (link to problem)? I am not able to think about a counter case thanks Submission

»
2 months ago, # |
  Vote: I like it 0 Vote: I do not like it

Can anyone help me with this WA on test 2 please 241674222